package cc.bnblogs.consumer.service;

import cc.bnblogs.consumer.entity.Order;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.apache.rocketmq.spring.core.RocketMQListener;
import org.springframework.stereotype.Service;

@Service
// consumerGroup可以自定义，topic需要和provider一致
@RocketMQMessageListener(consumerGroup = "myConsumer", topic = "orderTopic")
@Slf4j
public class OrderService implements RocketMQListener<Order> {

    @Override
    public void onMessage(Order order) {
        log.info("收到新订单了，{}，请及时处理",order);
    }
}
