package cc.bnblogs.provider.controller;

import cc.bnblogs.provider.entity.Order;
import cc.bnblogs.provider.service.IndexService;
import com.alibaba.csp.sentinel.annotation.SentinelResource;
import com.alibaba.nacos.shaded.org.checkerframework.checker.units.qual.A;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

@RestController
public class IndexController {
    @Value("${server.port}")
    private String port;

    @Autowired
    private IndexService indexService;

    @GetMapping("/index")
    public String getPort() {
        return this.port;
    }
    @GetMapping("/list")
    public String list() {
        return "list";
    }

    @GetMapping("/test1")
    public String test1() {
        return indexService.testService();
    }

    @GetMapping("/test2")
    public String test2() {
        return indexService.testService();
    }

    @GetMapping("/hot")
    @SentinelResource("hot")
    public String getHot(@RequestParam(value = "num1",required = false)Integer num1,
                         @RequestParam(value = "num2",required = false) Integer num2){
        return num1 + "-" + num2;
    }

    @Autowired
    private RocketMQTemplate rocketMQTemplate;

    @GetMapping("/create")
    public Order createOrder() {
        Order order = new Order(
                1,
                "tom",
                "123123",
                "shanghai",
                new Date()
        );
        rocketMQTemplate.convertAndSend("orderTopic",order);
        return order;
    }

    @GetMapping("/api1/demo1")
    public String demo1(){
        return "api1/demo1";
    }

    @GetMapping("/api1/demo2")
    public String demo2(){
        return "api1/demo2";
    }

    @GetMapping("/api2/demo1")
    public String demo3(){
        return "api2/demo1";
    }

    @GetMapping("/api2/demo2")
    public String demo4(){
        return "api2/demo2";
    }
}
