package cc.bnblogs.provider.test;


import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.consumer.DefaultMQPushConsumer;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyStatus;
import org.apache.rocketmq.client.consumer.listener.MessageListenerConcurrently;


@Slf4j
public class ConsumerTest {
    public static void main(String[] args) throws Exception {
        // 创建消息消费者
        DefaultMQPushConsumer consumer = new DefaultMQPushConsumer("myConsumer-Group");
        // 设置NameServer
        consumer.setNamesrvAddr("192.168.153.131:9876");
        // 指定订阅的主题和标签
        consumer.subscribe("myTopic","*");
        // 回调函数
        consumer.registerMessageListener((MessageListenerConcurrently)
                (list, consumeConcurrentlyContext) -> {
                    log.info("Message=>{}",list);
                    return ConsumeConcurrentlyStatus.CONSUME_SUCCESS;
                });
        // 启动消费者
        consumer.start();
    }
}
